import request from '@/apis/request.js'
const { get, post } = request

export const login = (data) => {
  return post('users/users/user/weChatAppletCallbackByPartner', data)
}

export const douYinLogin = (data) => {
  return post('users/users/user/douYinLogin?code=' + data)
}

export const douYinLoginByOpenid = (data) => {
  return post('users/users/user/douYinLoginByOpenid?openid=' + data)
}

export const douYinUserBinding = (data) => {
  return post('users/users/user/douYinUserBinding', data)
}

export const queryProvince = () => {
  return get('nakadai/nakadai/province/queryProvince')
}

export const queryCity = (data) => {
  return get('nakadai/nakadai/city/queryCity', data)
}

export const updateAvatars = url => {
  return post(`users/users/user/updateAvatars?url=` + url)
}

export const userBinding = (data) => {
  return post('users/users/user/userBinding', data)
}
export const sendPhoneOrEmailCode = (data) => {
  return post('users/users/userAccount/sendPhoneOrEmailCode', data)
}

export const examinePassword = (data) => {
  return post('users/users/userAccount/examinePassword', data)
}

export const getUserRolesPermissionMenu = (data) => {
  return get('users/users/user-role/getUserRolesPermissionMenu', data)
}

export const updatePersonCenter = (data) => {
  return post('users/users/userAccount/updatePersonCenter', data)
}

export const queryUserInfoDetails = () => {
  return get('users/users/userAccount/queryUserInfoDetails')
}

export const updateMyEmail = (data) => {
  return post('nakadai/nakadai/partner-team/updateMyEmail', data)
}

export const mailCodeSend = (data) => {
  return post('nakadai/nakadai/partner-team/mailCodeSend', data)
}

export const changeAccount = account => {
  return post(`users/users/applets/mine/changeAccount?account=${account}`)
}

export const changePhoneNumber = (phone, code) => {
  return post(`users/users/applets/mine/changePhoneNumber?phone=${phone}&code=${code}`)
}

export const checkIfAnAccountExists = account => {
  return post(`users/users/applets/mine/checkIfAnAccountExists?account=${account}`)
}

export const checkIfThePhoneNumberExists = phone => {
  return post(`users/users/applets/mine/checkIfThePhoneNumberExists?phone=${phone}`)
}

export const queryPartnerAccount = data => {
  return post(`nakadai/nakadai/partnerAccount/queryPartnerAccount?phone=${data.phone}&openId=${data.openId}&douYinOpenId=${data.douYinOpenId}`)
}

export const getSessionKey = data => {
  return post(`users/users/user/getSessionKey`, data)
}

export const partnerAccountApplication = data => {
  return post(`nakadai/nakadai/partnerAccount/partnerAccountApplication`, data)
}

export const loginByOpenid = openid => {
  return post(`users/users/user/loginByOpenid?openid=${openid}`)
}

export const checkWorkNumOrAccount = account => {
  return post(`occupationlab/occupationlab/architecture/checkWorkNumOrAccount?platformId=4&type=0&account=` + account)
}

export const updateUserAvatars = `http://39.108.250.202:9000/users/users/userAccount/updateUserAvatars`